﻿using UnityEngine;
using System.Collections;

public class PlayerCollision : MonoBehaviour {

	private bool isHit;
	private EnemyAI enemyStats;
	private PlayerStats playerStats;
	private ArenaCombatControl controller;
    private setAppearance playerLooks;
    private SpriteRenderer head;
    private SpriteRenderer face;
    private SpriteRenderer body;
    private SpriteRenderer legR; // looking AT the player right
    private SpriteRenderer legL; // looking AT the player left
    private SpriteRenderer arm;
    private SpriteRenderer forearm;

    private Color Original;

    void Start(){
		isHit = false;
        playerLooks = GameObject.Find("Player").GetComponent<setAppearance>(); // Access setAppearance object from characterDisplay
        enemyStats = GameObject.Find ("Enemy").GetComponent<EnemyAI> ();
		playerStats =  GameObject.Find ("Player").GetComponent<PlayerStats> ();
        Original = playerLooks.getColor();
    }
		
	// All player interactions handled here
	void OnTriggerEnter2D(Collider2D col){
		if (isHit == true) { // If hit recently, don't register hits
            return;
		}
		if (isHit == false) {
			if (col.tag == "enemyWeapon") { // Enemy hits with slash attack
				Debug.Log ("player hit by slash");
				isHit = true;
				int dmg;
				dmg = enemyStats.getDamageOutput ();
				playerStats.Damage (dmg);
				StartCoroutine (ExecuteAfterTime (1));
                StartCoroutine(FlashRedWhenHit(0.1f));
            }
			if (col.tag == "enemyKick") { // Enemy hits with kick attack
				Debug.Log ("player hit by kick");
				isHit = true;
				playerStats.Damage (5);
				StartCoroutine (ExecuteAfterTime (1));
                StartCoroutine(FlashRedWhenHit(0.1f));
            }
			if (col.tag == "projectile") {
				Debug.Log ("Player hit by projectile!");
				isHit = true;
				playerStats.Damage (5);
				StartCoroutine (ExecuteAfterTime (0.5f));
                StartCoroutine(FlashRedWhenHit(0.1f));
            }
		}

	}
	 // After parameter time, sets player hitable again
	IEnumerator ExecuteAfterTime(float time){ 
		yield return new WaitForSeconds (time);
		isHit = false;
        Debug.Log ("Player is able to get hit again!");
	}

    // After parameter time, sets player hitable again
    IEnumerator FlashRedWhenHit(float time) {
        yield return new WaitForSeconds(time);
        setAppearance.head.color = new Color(1, 0, 0, 1);
        setAppearance.face.color = new Color(1, 0, 0, 1); 
        setAppearance.body.color = new Color(1, 0, 0, 1); 
        setAppearance.legL.color = new Color(1, 0, 0, 1); 
        setAppearance.legR.color = new Color(1, 0, 0, 1); 
        setAppearance.arm.color = new Color(1, 0, 0, 1); 
        setAppearance.forearm.color = new Color(1, 0, 0, 1);
        yield return new WaitForSeconds(time);
        setAppearance.head.color = new Color(255, 255, 255, 1);
        setAppearance.face.color = new Color(255, 255, 255, 1);
        setAppearance.body.color = new Color(255, 255, 255, 1);
        setAppearance.legL.color = new Color(255, 255, 255, 1);
        setAppearance.legR.color = new Color(255, 255, 255, 1);
        setAppearance.arm.color = new Color(255, 255, 255, 1);
        setAppearance.forearm.color = new Color(255, 255, 255, 1);
        /*
        yield return new WaitForSeconds(time);
        playerLooks.addColor(1, 0, 0);
        yield return new WaitForSeconds(time);
        playerLooks.addColor(255, 255, 255);
        */
        yield return new WaitForSeconds(time);
        setAppearance.head.color = Original;
        setAppearance.face.color = Original;
        setAppearance.body.color = Original;
        setAppearance.legL.color = Original;
        setAppearance.legR.color = Original;
        setAppearance.arm.color = Original;
        setAppearance.forearm.color = Original;
        
    }



}
